<template>
  <details class="rui-collapsible-list-item" :open="showContent">
    <summary class="rui-collapsible-list-item__title">
      <span class="rui-collapsible-list-item__title__caption">
        <!-- @slot Caption, always visible -->
        <slot name="caption">{{ caption }}</slot>
      </span>

      <rui-toolbar v-if="$slots.actions" class="rui-collapsible-list-item__title__actions">
        <!-- @slot Right toolbar content -->
        <slot name="actions" />
      </rui-toolbar>
    </summary>

    <div class="rui-collapsible-list-item__content">
      <slot />
    </div>
  </details>
</template>
<script>
import RuiToolbar from '../Toolbar/Toolbar.vue'

/**
 * Meant to be used in a list of things, this component has collapsible content.
 *
 * @preset Default {
 *                   "props": { "caption": "My item" },
 *                   "slots": {
 *                     "default": "Item content",
 *                     "actions": "<button class=\"rui-button rui-button--creative\">Edit</button>"
 *                   }
 *                 }
 * @propsGroup State   [opened]
 * @propsGroup Content [caption]
 */
export default {
  name: 'RuiCollapsibleListItem',
  components: { RuiToolbar },
  props: {
    /** Main text */
    caption: { required: false, type: String, default: null },
    /** Whether to open the item by default */
    opened: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      showContent: this.$props.opened || false,
    }
  },
}
</script>
